=== debian/control ===
Source: trace-cmd
Section: devel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
Standards-Version: 3.8.4.0
Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc
Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git

Package: trace-cmd
Architecture: any
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: kernelshark
Description: Utility for retrieving and analyzing function tracing in the kernel
 This package contains the trace-cmd utility. Trace-cmd makes it easy to
 retrieve and analyze function traces from the Linux kernel while it is running.

Package: kernelshark
Architecture: any
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: trace-cmd
Description: Utilities for graphically analyzing function tracing in the kernel
 This package contains the kernelshark, trace-view, and trace-graph programs.
 Data for analysis may be generated by the trace-cmd utility.
