## trace-cmd 2.2.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
-TC_VERSION = 1
-TC_PATCHLEVEL = 0
-TC_EXTRAVERSION = 3
+TC_VERSION = 2
+TC_PATCHLEVEL = 2
+TC_EXTRAVERSION = 1
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -13,8 +13,21 @@
 
 MAKEFLAGS += --no-print-directory
 
-CC = $(CROSS_COMPILE)gcc
-AR = $(CROSS_COMPILE)ar
+# Makefiles suck: This macro sets a default value of $(2) for the
+# variable named by $(1), unless the variable has been set by
+# environment or command line. This is necessary for CC and AR
+# because make sets default values, so the simpler ?= approach
+# won't work as expected.
+define allow-override
+  $(if $(or $(findstring environment,$(origin $(1))),\
+            $(findstring command line,$(origin $(1)))),,\
+    $(eval $(1) = $(2)))
+endef
+
+# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
+$(call allow-override,CC,$(CROSS_COMPILE)gcc)
+$(call allow-override,AR,$(CROSS_COMPILE)ar)
+
 EXT = -std=gnu99
 INSTALL = install
 
@@ -30,17 +43,29 @@
 bindir = $(prefix)/$(bindir_relative)
 man_dir = $(prefix)/share/man
 man_dir_SQ = '$(subst ','\'',$(man_dir))'
-
-export man_dir man_dir_SQ INSTALL
+html_install = $(prefix)/share/kernelshark/html
+html_install_SQ = '$(subst ','\'',$(html_install))'
+img_install = $(prefix)/share/kernelshark/html/images
+img_install_SQ = '$(subst ','\'',$(img_install))'
+
+export man_dir man_dir_SQ html_install html_install_SQ INSTALL
+export img_install img_install_SQ
 export DESTDIR DESTDIR_SQ
 
 ifeq ($(prefix),$(HOME))
 plugin_dir = $(HOME)/.trace-cmd/plugins
+python_dir = $(HOME)/.trace-cmd/python
 else
-plugin_dir = $(prefix)/share/trace-cmd/plugins
-PLUGIN_DIR = -DPLUGIN_DIR=$(plugin_dir)
+plugin_dir = $(prefix)/lib/trace-cmd/plugins
+python_dir = $(prefix)/lib/trace-cmd/python
+PLUGIN_DIR = -DPLUGIN_DIR="$(plugin_dir)"
+PYTHON_DIR = -DPYTHON_DIR="$(python_dir)"
 PLUGIN_DIR_SQ = '$(subst ','\'',$(PLUGIN_DIR))'
-endif
+PYTHON_DIR_SQ = '$(subst ','\'',$(PYTHON_DIR))'
+endif
+
+HELP_DIR = -DHELP_DIR=$(html_install)
+HELP_DIR_SQ = '$(subst ','\'',$(HELP_DIR))'
 
 # copy a bit from Linux kbuild
 
@@ -50,6 +75,35 @@
 ifndef VERBOSE
   VERBOSE = 0
 endif
+
+ifndef NO_PYTHON
+PYTHON		:= ctracecmd.so
+PYTHON_GUI	:= ctracecmd.so ctracecmdgui.so
+
+# Can build python?
+ifeq ($(shell sh -c "python-config --includes > /dev/null 2>&1 && echo y"), y)
+	PYTHON_PLUGINS := plugin_python.so
+	BUILD_PYTHON := $(PYTHON) $(PYTHON_PLUGINS)
+	PYTHON_SO_INSTALL := ctracecmd.install
+	PYTHON_PY_INSTALL := event-viewer.install tracecmd.install tracecmdgui.install
+endif
+endif # NO_PYTHON
+
+# $(call test-build, snippet, ret) -> ret if snippet compiles
+#                                  -> empty otherwise
+test-build = $(if $(shell sh -c 'echo "$(1)" | \
+	$(CC) -o /dev/null -c -x c - > /dev/null 2>&1 && echo y'), $2)
+
+# have udis86 disassembler library?
+udis86-flags := $(call test-build,\#include <udis86.h>,-DHAVE_UDIS86 -ludis86)
+
+define BLK_TC_FLUSH_SOURCE
+#include <linux/blktrace_api.h>
+int main(void) { return BLK_TC_FLUSH; }
+endef
+
+# have flush/fua block layer instead of barriers?
+blk-flags := $(call test-build,$(BLK_TC_FLUSH_SOURCE),-DHAVE_BLK_TC_FLUSH)
 
 ifeq ("$(origin O)", "command line")
   BUILD_OUTPUT := $(O)
@@ -100,11 +154,12 @@
 bindir_SQ = $(subst ','\'',$(bindir))
 bindir_relative_SQ = $(subst ','\'',$(bindir_relative))
 plugin_dir_SQ = $(subst ','\'',$(plugin_dir))
+python_dir_SQ = $(subst ','\'',$(python_dir))
 
 LIBS = -L. -ltracecmd -ldl
 LIB_FILE = libtracecmd.a
 
-PACKAGES= gtk+-2.0
+PACKAGES= gtk+-2.0 libxml-2.0 gthread-2.0
 
 ifndef BUILDGUI
  BUILDGUI = 0
@@ -132,6 +187,7 @@
 G		=
 N 		= @/bin/true ||
 
+CONFIG_FLAGS	+= $(HELP_DIR_SQ)
 else
 
 CONFIG_INCLUDES = 
@@ -156,9 +212,28 @@
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 KERNELSHARK_VERSION = $(KS_VERSION).$(KS_PATCHLEVEL).$(KS_EXTRAVERSION)
 
-INCLUDES = -I. -I/usr/local/include $(CONFIG_INCLUDES)
-
-CFLAGS = -g -Wall $(CONFIG_FLAGS) $(INCLUDES) $(PLUGIN_DIR_SQ)
+INCLUDES = -I. $(CONFIG_INCLUDES)
+
+include features.mk
+
+# Set compile option CFLAGS if not set elsewhere
+CFLAGS ?= -g -Wall -D_GNU_SOURCE
+LDFLAGS ?=
+
+ifndef NO_PTRACE
+ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
+	NO_PTRACE = 1
+	CFLAGS += -DWARN_NO_PTRACE
+endif
+endif
+
+ifdef NO_PTRACE
+CFLAGS += -DNO_PTRACE
+endif
+
+# Append required CFLAGS
+override CFLAGS += $(CONFIG_FLAGS) $(INCLUDES) $(PLUGIN_DIR_SQ)
+override CFLAGS += $(udis86-flags) $(blk-flags)
 
 ifeq ($(VERBOSE),1)
   Q =
@@ -187,7 +262,7 @@
 
 do_app_build =						\
 	($(print_app_build)				\
-	$(CC) $^ -rdynamic -o $@ $(CONFIG_LIBS) $(LIBS))
+	$(CC) $^ -rdynamic -o $@ $(LDFLAGS) $(CONFIG_LIBS) $(LIBS))
 
 do_compile_shared_library =			\
 	($(print_shared_lib_compile)		\
@@ -199,7 +274,7 @@
 
 do_plugin_build =				\
 	($(print_plugin_build)			\
-	$(CC) -shared -nostartfiles -o $@ $<)
+	$(CC) $(CFLAGS) $(LDFLAGS) -shared -nostartfiles -o $@ $<)
 
 do_build_static_lib =				\
 	($(print_static_lib_build)		\
@@ -221,28 +296,33 @@
 %.o: $(src)/%.c
 	$(Q)$(call check_gui)
 
-TRACE_CMD_OBJS = trace-cmd.o trace-usage.o trace-read.o trace-split.o trace-listen.o
-TRACE_VIEW_OBJS = trace-view.o trace-view-store.o trace-filter.o trace-compat.o \
-	trace-hash.o
-TRACE_GRAPH_OBJS = trace-graph.o trace-compat.o trace-hash.o trace-filter.o \
-		trace-plot.o trace-plot-cpu.o trace-plot-task.o
-TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS)
-TRACE_GRAPH_MAIN_OBJS = trace-graph-main.o $(TRACE_GRAPH_OBJS)
-KERNEL_SHARK_OBJS = $(TRACE_VIEW_OBJS) $(TRACE_GRAPH_OBJS) kernel-shark.o
-
-PEVENT_LIB_OBJS = parse-events.o trace-seq.o parse-filter.o
+TRACE_GUI_OBJS = trace-filter.o trace-compat.o trace-hash.o trace-dialog.o \
+		trace-xml.o
+TRACE_CMD_OBJS = trace-cmd.o trace-record.o trace-read.o trace-split.o trace-listen.o \
+	 trace-stack.o trace-options.o trace-hist.o trace-mem.o
+TRACE_VIEW_OBJS = trace-view.o trace-view-store.o
+TRACE_GRAPH_OBJS = trace-graph.o trace-plot.o trace-plot-cpu.o trace-plot-task.o
+TRACE_VIEW_MAIN_OBJS = trace-view-main.o $(TRACE_VIEW_OBJS) $(TRACE_GUI_OBJS)
+TRACE_GRAPH_MAIN_OBJS = trace-graph-main.o $(TRACE_GRAPH_OBJS) $(TRACE_GUI_OBJS)
+KERNEL_SHARK_OBJS = $(TRACE_VIEW_OBJS) $(TRACE_GRAPH_OBJS) $(TRACE_GUI_OBJS) \
+	trace-capture.o kernel-shark.o
+
+PEVENT_LIB_OBJS = event-parse.o trace-seq.o parse-filter.o parse-utils.o
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
-			trace-output.o trace-record.o
+			trace-output.o trace-recorder.o trace-restore.o trace-usage.o \
+			trace-blk-hack.o kbuffer-parse.o
 
 PLUGIN_OBJS = plugin_hrtimer.o plugin_kmem.o plugin_sched_switch.o \
-	plugin_mac80211.o plugin_jbd2.o
+	plugin_mac80211.o plugin_jbd2.o plugin_function.o plugin_kvm.o \
+	plugin_blk.o
 
 PLUGINS := $(PLUGIN_OBJS:.o=.so)
 
 ALL_OBJS = $(TRACE_CMD_OBJS) $(KERNEL_SHARK_OBJS) $(TRACE_VIEW_MAIN_OBJS) \
 	$(TRACE_GRAPH_MAIN_OBJS) $(TCMD_LIB_OBJS) $(PLUGIN_OBJS)
 
-CMD_TARGETS = trace_plugin_dir tc_version.h libparsevent.a $(LIB_FILE) trace-cmd  $(PLUGINS)
+CMD_TARGETS = trace_plugin_dir trace_python_dir tc_version.h libparsevent.a $(LIB_FILE) \
+	trace-cmd  $(PLUGINS) $(BUILD_PYTHON)
 
 GUI_TARGETS = ks_version.h trace-graph trace-view kernelshark
 
@@ -336,8 +416,8 @@
 tc_version.h: force
 	$(Q)$(N)$(call update_version.h)
 
-define update_plugin_dir
-	(echo 'PLUGIN_DIR=$(PLUGIN_DIR)' > $@.tmp;	\
+define update_dir
+	(echo $1 > $@.tmp;	\
 	if [ -r $@ ] && cmp -s $@ $@.tmp; then		\
 		rm -f $@.tmp;				\
 	else						\
@@ -347,7 +427,10 @@
 endef
 
 trace_plugin_dir: force
-	$(Q)$(N)$(call update_plugin_dir)
+	$(Q)$(N)$(call update_dir, 'PLUGIN_DIR=$(PLUGIN_DIR)')
+
+trace_python_dir: force
+	$(Q)$(N)$(call update_dir, 'PYTHON_DIR=$(PYTHON_DIR)')
 
 ## make deps
 
@@ -379,97 +462,3 @@
 $(all_objs) : %.o : .%.d
 
 ifeq ($(BUILDGUI), 1)
-dep_includes := $(wildcard $(gui_deps))
-else
-dep_includes := $(wildcard $(non_gui_deps))
-endif
-
-ifneq ($(dep_includes),)
- include $(dep_includes)
-endif
-
-show_gui_make:
-	@echo "Note: to build the gui, type \"make gui\""
-
-show_gui_done:
-	@echo "gui build complete"
-
-PHONY += show_gui_make
-
-tags:	force
-	$(RM) tags
-	find . -name '*.[ch]' | xargs ctags
-
-TAGS:	force
-	$(RM) TAGS
-	find . -name '*.[ch]' | xargs etags
-
-PLUGINS_INSTALL = $(subst .so,.install,$(PLUGINS))
-
-define do_install
-	$(print_install)				\
-	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
-		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
-	fi;						\
-	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
-endef
-
-$(PLUGINS_INSTALL): %.install : %.so force
-	$(Q)$(call do_install,$<,$(plugin_dir_SQ))
-
-install_plugins: $(PLUGINS_INSTALL)
-
-install_cmd: all_cmd install_plugins
-	$(Q)$(call do_install,trace-cmd,$(bindir_SQ))
-
-install: install_cmd
-	@echo "Note: to install the gui, type \"make install_gui\""
-
-install_gui: install_cmd gui
-	$(Q)$(call do_install,trace-view,$(bindir_SQ))
-	$(Q)$(call do_install,trace-graph,$(bindir_SQ))
-	$(Q)$(call do_install,kernelshark,$(bindir_SQ))
-
-doc:
-	$(MAKE) -C $(src)/Documentation all
-
-doc_clean:
-	$(MAKE) -C $(src)/Documentation clean
-
-install_doc:
-	$(MAKE) -C $(src)/Documentation install
-
-clean:
-	$(RM) *.o *~ $(TARGETS) *.a *.so ctracecmd_wrap.c .*.d
-	$(RM) tags TAGS trace_plugin_dir
-
-
-##### PYTHON STUFF #####
-
-PYTHON_INCLUDES = `python-config --includes`
-PYGTK_CFLAGS = `pkg-config --cflags pygtk-2.0`
-
-ctracecmd.so: $(TCMD_LIB_OBJS)
-	swig -Wall -python -noproxy ctracecmd.i
-	gcc -fpic -c $(PYTHON_INCLUDES)  ctracecmd_wrap.c
-	$(CC) --shared $^ ctracecmd_wrap.o -o ctracecmd.so
-
-ctracecmdgui.so: $(TRACE_VIEW_OBJS) $(LIB_FILE)
-	swig -Wall -python -noproxy ctracecmdgui.i
-	gcc -fpic -c  $(CFLAGS) $(INCLUDES) $(PYTHON_INCLUDES) $(PYGTK_CFLAGS) ctracecmdgui_wrap.c
-	$(CC) --shared $^ $(LIBS) $(CONFIG_LIBS) ctracecmdgui_wrap.o -o ctracecmdgui.so
-
-PHONY += python
-python: ctracecmd.so
-
-PHONY += python-gui
-python-gui: ctracecmd.so ctracecmdgui.so 
-
-endif # skip-makefile
-
-PHONY += force
-force:
-
-# Declare the contents of the .PHONY variable as phony.  We keep that
-# information in a variable so we can use it in if_changed and friends.
-.PHONY: $(PHONY)
