=== Documentation/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 define manpage.xsl
-	if [ ! -f ${MANPAGE_DOCBOOK_XSL} ]; then 		\
+	if [ -z ${MANPAGE_DOCBOOK_XSL} ]; then 			\
 		echo "*********************************";	\
 		echo "** No docbook.xsl is installed **";	\
 		echo "** Can't make man pages        **";	\
@@ -46,7 +46,7 @@
 # Most likely a docbook.xsl is already installed on the users system
 # instead of creating a new wheel, lets reuse what's already there.
 #
-MANPAGE_DOCBOOK_XSL =  $(shell locate manpages/docbook.xsl | head -1)
+MANPAGE_DOCBOOK_XSL ?=  $(shell locate manpages/docbook.xsl | head -1)
 
 $(obj)/%.xsl: $(src)/%.txt
 	$(Q)mkdir -p $(obj)
@@ -87,7 +87,25 @@
 $(MAN5_INSTALL): %.5.install : %.5 force
 	$(Q)$(call do_install,$<,$(man_dir_SQ)/man5)
 
-install: $(MAN1_INSTALL) $(MAN5_INSTALL)
+html_dir = $(src)/HTML
+image_dir = $(html_dir)/images
+
+HTML = $(wildcard $(html_dir)/*.html)
+IMGS = $(wildcard $(image_dir)/*.png)
+
+HTML_INSTALL = $(subst .html,.html.install,$(HTML))
+IMGS_INSTALL = $(subst .png,.png.install,$(IMGS))
+
+$(HTML_INSTALL): %.html.install : %.html force
+	$(Q)$(call do_install,$<,'$(html_install_SQ)')
+
+$(IMGS_INSTALL): %.png.install : %.png force
+	$(Q)$(call do_install,$<,'$(img_install_SQ)')
+
+
+GUI_INSTALL = $(HTML_INSTALL) $(IMGS_INSTALL)
+
+install: $(MAN1_INSTALL) $(MAN5_INSTALL) $(GUI_INSTALL)
 
 clean:
 	(cd $(obj); \
