=== debian/control ===
--- 
+++ 
@@ -2,23 +2,24 @@
 Section: devel
 Priority: optional
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
-Standards-Version: 3.8.4.0
-Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc
+Uploaders: Seth Forshee <seth.forshee@canonical.com>, Kamal Mostafa <kamal@canonical.com>
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
 Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git
 
 Package: trace-cmd
-Architecture: any
+Architecture: linux-any
 Section: devel
 Priority: optional
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python
 Suggests: kernelshark
 Description: Utility for retrieving and analyzing function tracing in the kernel
  This package contains the trace-cmd utility. Trace-cmd makes it easy to
  retrieve and analyze function traces from the Linux kernel while it is running.
 
 Package: kernelshark
-Architecture: any
+Architecture: linux-any
 Section: devel
 Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}
