## trace-cmd 2.5.3

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # trace-cmd version
 TC_VERSION = 2
 TC_PATCHLEVEL = 5
-TC_EXTRAVERSION = 1
+TC_EXTRAVERSION = 3
 
 # Kernel Shark version
 KS_VERSION = 0
@@ -320,7 +320,7 @@
 TCMD_LIB_OBJS = $(PEVENT_LIB_OBJS) trace-util.o trace-input.o trace-ftrace.o \
 			trace-output.o trace-record.o trace-recorder.o \
 			trace-restore.o trace-usage.o trace-blk-hack.o \
-			kbuffer-parse.o event-plugin.o
+			kbuffer-parse.o event-plugin.o trace-hooks.o
 
 PLUGIN_OBJS =
 PLUGIN_OBJS += plugin_jbd2.o
@@ -456,5 +456,3 @@
 all_objs := $(sort $(ALL_OBJS))
 all_deps := $(all_objs:%.o=.%.d)
 gui_deps := $(gui_objs:%.o=.%.d)
-non_gui_deps = $(filter-out $(gui_deps),$(all_deps))
-
