=== debian/changelog ===
trace-cmd (2.6-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release
  * Build-depend on dh-python
  * Bump standards-version to 3.9.8 (no change needed)

 -- Javi Merino <vicho@debian.org>  Sun, 17 Jul 2016 13:40:44 +0100
