## trace-cmd 2.6.1

=== debian/changelog ===
trace-cmd (2.6.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update to v2.6.1:
    Fixs segfault while processing certain trace files (Closes: #867440).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 12 Sep 2017 21:50:27 +0200
