=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
 Uploaders: Seth Forshee <seth.forshee@canonical.com>, Kamal Mostafa <kamal@canonical.com>
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig
+Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 7), cdbs, asciidoc, docbook-xsl, libgtk2.0-dev, xsltproc, libxml2-dev, python-dev (>= 2.6.6-3), python-gtk2-dev, swig, dh-python
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/rostedt/trace-cmd.git
 Vcs-Browser: http://git.kernel.org/?p=linux/kernel/git/rostedt/trace-cmd.git
