=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,6 @@
 DEB_MAKE_CLEAN_TARGET=clean doc_clean $(OPTS)
 DEB_MAKE_BUILD_TARGET=gui doc $(OPTS)
 DEB_MAKE_INSTALL_TARGET=install_gui install_doc $(OPTS)
+
+binary-install/trace-cmd::
+	dh_python2 -ptrace-cmd /usr/lib/trace-cmd/python
